import thread
#from threading import Thread
import xmlrpclib
from SimpleXMLRPCServer import SimpleXMLRPCServer
from socket import gethostname 
"""
XMLRPCServer is an extension of SimpleXMLRPCServer
it adds quit functionality so that
you can call "stop" to stop the server.
this enables termination of all processes in the patient (when he's ready)
lso it is aware of the central registration of services that we do,
and properly subscribes the service there.

 test this by
 1. start up NetworkTools server using
import Network.NetworkTools
a=Network.NetworkTools.NetworkTools()

 2. start an XMLRPCServer with
import Network.XMLRPCServer
s=Network.XMLRPCServer.XMLRPCServer("hallo",("localhost",8010))
def test(self): print "hallo"
s.register_function(test,"test")
s.run()
"""

class XMLRPCServer(SimpleXMLRPCServer):
	
	running=False
	servicename=0
	netinfo=0
	
	# @param servicenm is the name of the service as to appear in the networktools
	# usually of the form patientid/servicename
	# @param info is the (machinename, port number) under which XMLRCP calls can be made for that service
	# remember to call run() to start the deamon after you have started up.
	# 
	def __init__(self,servicenm,info):
		SimpleXMLRPCServer.__init__(self,info)
		self.servicename=servicenm
		self.netinfo=info
		self.register_function(self.stop,"stop")

		
	#call this to stop the server, but it will continue ONE MORE CALL
	#TODO kill immediately and terminate current call.
	#maybe by calling right now from here???
	def stop(self):
		self.running=False
		return 1
	
	# you can override this to handle close-down functionality
	# this will be called as last action before the thread exits.
	def handle_stop(self):
		pass
		
		
	# runs the server IN A SEPARATE THREAD
	# and registers with the registry
	# call stop_server() to stop the server
	def run(self):
		print "run"
		if self.running:
			raise Exception("server already running!")
		self.running=True
		#Thread.__init__(self)
		#thread.start_new_thread(self.runtheserver,(self,2)) # start the server thread


	
	# this is the server thread
	# @param is unused at this moment.
	def runtheserver(self,*param):
		print "runtheserver"
		self.running=True
		#self.serve_forever()
		#print "XMLRCPServer for "+self.servicename+" has been terminated"
		
	def serve_once(self):
		self.handle_request()
		return 1
	
	
	def serve_forever(self):
		print "server starting"
		while self.running:
			print "voor request"
			self.handle_request()
			print "na request"
			
		self.handle_stop()
		